// Matthew Kraus
//
// queue.c
//
// Implementation of an array based circular queue
//


// I N C L U D E S ////////////////////////////////////////////////////////////////////////////////
#include "queue.h"
//#include <stdlib.h>

//
// F U N C T I O N S //////////////////////////////////////////////////////////////////////////////
//


///////////////////////////////////////////////////////////////////////////////////////////////////
//
void queue_create(PQUEUE_DATA queueData, int size)
{
	//queueData->circularBuffer = (pQUEUE_DATATYPE)malloc(sizeof(QUEUE_DATATYPE) * size);

	queueData->head = 0;
	queueData->tail = 0;
	queueData->size = size;
	queueData->numElementsInQueue = 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
void queue_destroy(PQUEUE_DATA queueData)
{
	//if (queueData->circularBuffer != NULL) free(queueData->circularBuffer);
	//queueData->circularBuffer = NULL;

	queueData->size = 0;
	queueData->numElementsInQueue = 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
BOOL queue_isEmpty(PQUEUE_DATA queueData)
{
	return queueData->numElementsInQueue == 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
BOOL queue_isFull(PQUEUE_DATA queueData)
{
	return queueData->numElementsInQueue == queueData->size;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
BOOL queue_push(PQUEUE_DATA queueData, QUEUE_DATATYPE val)
{
	if (queue_isFull(queueData) ) return FALSE;

	queueData->circularBuffer[queueData->tail++] = val;
	++queueData->numElementsInQueue;

	if (queueData->tail > queueData->size - 1) queueData->tail = 0;

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
BOOL queue_pop(PQUEUE_DATA queueData, pQUEUE_DATATYPE retVal)
{
	if (queue_isEmpty(queueData) ) return FALSE;

	*retVal = queueData->circularBuffer[queueData->head++];
	--queueData->numElementsInQueue;

	if (queueData->head > queueData->size - 1) queueData->head = 0;

	return TRUE;
}

int queue_pop_all(PQUEUE_DATA queueData, pQUEUE_DATATYPE retval, int max)
{
	int size = queueData->numElementsInQueue;
	int counter = max;
	while (queue_pop(queueData, retval) && counter > 1)
	{
		retval++;
		counter--;
	}
	if (size > max)
		return max;
	return size;
}
