// Matthew Kraus
//
// queue.h -- an array based circular queue
//
#ifndef _QUEUE_INCLUDED
#define _QUEUE_INCLUDED

#ifndef TYPES_H_INCLUDED
	#include "types.h"
#endif

#define MAX_QUEUE_ELEMENTS 32

// type of data that the queue stores
typedef unsigned char  QUEUE_DATATYPE;
typedef unsigned char* pQUEUE_DATATYPE;

typedef struct QUEUE_DATA_
{
	//pQUEUE_DATATYPE circularBuffer;
	QUEUE_DATATYPE circularBuffer[MAX_QUEUE_ELEMENTS];
	unsigned int tail;
	unsigned int size;
	unsigned int head;
	unsigned int numElementsInQueue;
} QUEUE_DATA, *PQUEUE_DATA;


void queue_create(PQUEUE_DATA queueData, int size);
void queue_destroy(PQUEUE_DATA queueData);

BOOL queue_isEmpty(PQUEUE_DATA queueData);
BOOL queue_isFull(PQUEUE_DATA queueData);

BOOL queue_push(PQUEUE_DATA queueData, QUEUE_DATATYPE val);
BOOL queue_pop(PQUEUE_DATA queueData, pQUEUE_DATATYPE retVal);
int queue_pop_all(PQUEUE_DATA queueData, pQUEUE_DATATYPE retval, int max);

#endif
